#!/bin/bash
# $Revision: 1.4 $
# STANDARD 1.0
# PLUGIN TYPE:WEB

######################################################################
echo "BEGIN: $(basename $0) $*" >&2
######################################################################
# Questo e' un "bash script plugin" per BuDuScRiPt/budus_xdcc.sh

# Il suo scopo e' quello di fornire un "motore di ricerca".

######################################################################
# Include la Libreria di Funzioni XDCC
source $(dirname ${0})/budus_XBSPSE_LIB.sh

################################################################################
# Verifica la presenza di curl _________________________________________________
curl_version=$(curl --version 2> /dev/null)
if [ "${curl_version}" == "" ]; then
    printf '/ECHO %%C4,1%%B[XDCC]\t ERRORE FATALE:%%O Programma %%Bcurl%%O non trovato;  necessario installarlo per usare questo XBSPSE (%%B %s%%O).\n' "$(basename $0)"
    
    exit 1;
fi

######################################################################
# Lo script "budus_xdcc.sh" invoca questo script passando, come primo
# parametro, un codice casuale che serve per calcolare il file dentro
# al quale immagazzinare il risultato opportunamente filtrato.
RANDOM_NUMBER=${1}

# Il secondo parametro e' il numero di secondi d'attesa del risultato
# dal sito web interrogato, trascorsi i quali, si deve interrompere la
# ricerca del plugin.
WGET_TIMEOUT=${2}

# Il terzo parametro rappresenta la "stringa di ricerca" immessa
# dall'utente.
SEARCH_STRING=${3}

######################################################################
# Il TIMEOUT degli XBSPSE di tipo WEB deve essere configurato ad un
# massimo di 32 secondi.
if [ ${WGET_TIMEOUT:-33} -gt 32 ]; then
    WGET_TIMEOUT=32
fi

######################################################################
# VARIABILI AD USO DEL FILTRO
######################################################################
db_url="http://www.xdccfinder.com/results.php"
wget_option="-q -t 1 -O - -T ${WGET_TIMEOUT}"

######################################################################
# Vengono create e inizializzate le variabili base operative.
make_plugin_variables "${0}"

######################################################################
# Codifica alcuni caratteri speciali
SEARCH_STRING=$(echo "${SEARCH_STRING}" \
    | sed 's@&@%2F@g' \
    | sed 's@%@%26@g' \
    | sed 's@\$@%24@g' \
    | sed 's@%@%25@g' \
    | sed 's@&@%2F@g' \
    | sed 's@,@%2C@g' \
    | sed 's@;@%3B@g' \
    | sed 's@:@%3A@g' \
    | sed 's@+@%2B@g' \
    | sed 's@ @+@g')

######################################################################
curl -i -d kw="${SEARCH_STRING}" -s ${db_url} --max-time ${WGET_TIMEOUT} | sed 's/\r//g' > ${plugin_tempfile}
cp -f ${plugin_tempfile} /tmp/budus_XDCC_db_${plugin_name}.dat

######################################################################
if [ ! -f "${plugin_tempfile}" ]; then
    echo > "${plugin_tempfile}"
    if [ ! -f "${plugin_tempfile}" ]; then
	echo "/ECHO %C4,1Non sono in grado di creare files temporanei in /tmp, problema di permessi ?"
	echo "/ECHO (${plugin_tempfile})"
	exit 1;
    else
	echo "/ECHO %C4,1Il plugin non e' stato in grado di generare il database. Segnalare il problema a UDA'Software, se persiste."
	exit 1;
    fi
fi

######################################################################
# Filtraggio
# L'output del filtro e' rappresentato da 8 campi separati dal
# carattere di tabulazione '\t', ovvero:
# NETWORK_NAME NETWORK_HOST CHANNEL BOT_NAME ID FILE_NAME SIZE COMMAND
#       1            2         3        4    5      6      7      8
######################################################################
cat ${plugin_tempfile} \
    | tr '\n' ' ' \
    | tr '\t' ' ' \
    | sed 's/<tr onclick="toggle/\nXDCC_RECORD:/g' \
    | grep -F 'XDCC_RECORD:' \
    | sed 's@XDCC_RECORD:.* onmouseover="this.className=.[a-z]*." onmouseout="this.className=.[a-z]*." class=".[a-z]*."> *<td width="">@@' \
    | sed 's@.*<a href="#" title="@@' \
    | sed 's@" onclick="this.blur;return false;">more info</a></td> *<td width=""><a href="results.php?nw=[^"]*">@\t@' \
    | sed 's@</a></td> *<td width=""><a href="results.php.nw=[^;]*;ch=[^"]*">@\t@' \
    | sed 's@</td> *<td width="">@\t@' \
    | sed 's@</td>.*<strong>Bot Nick:</strong>@_BUDUS_SEPARATOR_COMMA_@' \
    | sed 's@_BUDUS_SEPARATOR_COMMA_.nbsp;<a href="results.php?nw=[^;]*;ch=.amp;bt=[^"]*">@\t@' \
    | sed 's@</a></div>.*size="35" value="@\t@' \
    | cut -f1 -d '"' \
    | awk -F'\t' '{printf $2"\t\t"$3"\t"$5"\t#0\t"$1"\t"$4"\t"$6"\n"}' \
    > ${plugin_tempfile}.database

# ATTENZIONE: Questo XBSPSE non inserisce nel database di output
# l'host del server IRC (manca nel file dati).

# ATTENZIONE: Questo XBSPSE non inserisce nel database di output
# l'ID del pacchetto (manca nel file dati).

######################################################################
rm -f ${plugin_tempfile}

######################################################################
echo "END  : $(basename $0) $*" >&2
######################################################################